package io.accumulatenetwork.sdk.generated.protocol;

/**
    GENERATED BY go run ./tools/cmd/gen-api. DO NOT EDIT.
**/

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonTypeName;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import io.accumulatenetwork.sdk.protocol.Marshallable;
import io.accumulatenetwork.sdk.protocol.Url;
import io.accumulatenetwork.sdk.support.Marshaller;
import io.accumulatenetwork.sdk.support.serializers.HexDeserializer;
import io.accumulatenetwork.sdk.support.serializers.HexSerializer;
// UnionType: 
// UnionValue: 

@JsonIgnoreProperties(ignoreUnknown = true)
@JsonTypeName("PartitionAnchor")
@JsonInclude(JsonInclude.Include.NON_NULL)
public class PartitionAnchor implements Marshallable {
	private Url source;
	private long majorBlockIndex;
	private long minorBlockIndex;
	private long rootChainIndex;
	private byte[] rootChainAnchor;
	private byte[] stateTreeAnchor;

    //
	public Url getSource() {
	    return source;
	}
	public void setSource(final Url value) {
	    this.source = value;
	}

	public PartitionAnchor source(final Url value) {
	    setSource(value);
	    return this;
	}
	public PartitionAnchor source(final String value) {
	    setSource(Url.toAccURL(value));
	    return this;
	}
	public long getMajorBlockIndex() {
	    return majorBlockIndex;
	}
	public void setMajorBlockIndex(final long value) {
	    this.majorBlockIndex = value;
	}

	public PartitionAnchor majorBlockIndex(final long value) {
	    setMajorBlockIndex(value);
	    return this;
	}
	public long getMinorBlockIndex() {
	    return minorBlockIndex;
	}
	public void setMinorBlockIndex(final long value) {
	    this.minorBlockIndex = value;
	}

	public PartitionAnchor minorBlockIndex(final long value) {
	    setMinorBlockIndex(value);
	    return this;
	}
	public long getRootChainIndex() {
	    return rootChainIndex;
	}
	public void setRootChainIndex(final long value) {
	    this.rootChainIndex = value;
	}

	public PartitionAnchor rootChainIndex(final long value) {
	    setRootChainIndex(value);
	    return this;
	}
	@JsonDeserialize(using = HexDeserializer.class)
	public byte[] getRootChainAnchor() {
	    return rootChainAnchor;
	}
	@JsonSerialize(using = HexSerializer.class)
	public void setRootChainAnchor(final byte[] value) {
	    this.rootChainAnchor = value;
	}

	public PartitionAnchor rootChainAnchor(final byte[] value) {
	    setRootChainAnchor(value);
	    return this;
	}
	public PartitionAnchor rootChainAnchor(final String value) {
		try {
			setRootChainAnchor(io.accumulatenetwork.sdk.commons.codec.binary.Hex.decodeHex(value));
		} catch (io.accumulatenetwork.sdk.commons.codec.DecoderException e) {
			throw new RuntimeException(e);
		}
	    return this;
	}
	@JsonDeserialize(using = HexDeserializer.class)
	public byte[] getStateTreeAnchor() {
	    return stateTreeAnchor;
	}
	@JsonSerialize(using = HexSerializer.class)
	public void setStateTreeAnchor(final byte[] value) {
	    this.stateTreeAnchor = value;
	}

	public PartitionAnchor stateTreeAnchor(final byte[] value) {
	    setStateTreeAnchor(value);
	    return this;
	}
	public PartitionAnchor stateTreeAnchor(final String value) {
		try {
			setStateTreeAnchor(io.accumulatenetwork.sdk.commons.codec.binary.Hex.decodeHex(value));
		} catch (io.accumulatenetwork.sdk.commons.codec.DecoderException e) {
			throw new RuntimeException(e);
		}
	    return this;
	}
    public byte[] marshalBinary() {
        final var marshaller = new Marshaller();
        if (!(this.source == null)) {
            marshaller.writeUrl(1, this.source);
        }
        if (!(this.majorBlockIndex == 0)) {
            marshaller.writeUint(2, this.majorBlockIndex);
        }
        if (!(this.minorBlockIndex == 0)) {
            marshaller.writeUint(3, this.minorBlockIndex);
        }
        if (!(this.rootChainIndex == 0)) {
            marshaller.writeUint(4, this.rootChainIndex);
        }
        if (!(this.rootChainAnchor == null || this.rootChainAnchor.length == 0)) {
            marshaller.writeHash(5, this.rootChainAnchor);
        }
        if (!(this.stateTreeAnchor == null || this.stateTreeAnchor.length == 0)) {
            marshaller.writeHash(6, this.stateTreeAnchor);
        }
        return marshaller.array();
    }
}
